Package icyllis.modernui.core

# Interface Choreographer.FrameCallback

Enclosing class:
  `Choreographer`

Functional Interface:
  This is a functional interface and can therefore be used as the assignment target for a lambda expression or method reference.

@FunctionalInterface public static interface Choreographer.FrameCallback
Implement this interface to receive a callback when a new display frame is being rendered. The callback is invoked on the `Looper` thread to which the `Choreographer` is attached.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `doFrame(Choreographer choreographer, long frameTimeNanos)`
  Called when a new display frame is being rendered.

- ## Method Details

  - ### doFrame

    void doFrame(@NonNull Choreographer choreographer, long frameTimeNanos)
    Called when a new display frame is being rendered.

    This method provides the time in nanoseconds when the frame started being rendered. The frame time provides a stable time base for synchronizing animations and drawing. It should be used instead of `Core.timeMillis()` or `Core.timeNanos()` for animations and drawing in the UI. Using the frame time helps to reduce inter-frame jitter because the frame time is fixed at the time the frame was scheduled to start, regardless of when the animations or drawing callback actually runs. All callbacks that run as part of rendering a frame will observe the same frame time so using the frame time also helps to synchronize effects that are performed by different callbacks.

    Please note that the framework already takes care to process animations and drawing using the frame time as a stable time base. Most applications should not need to use the frame time information directly.

    Parameters:
      `choreographer` - the choreographer called this method
      `frameTimeNanos` - The time in nanoseconds when the frame started being rendered, in the `Core.timeNanos()` timebase. Divide this value by `1000000` to convert it to the `Core.timeMillis()` time base.